/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author gauthier.muata
 */
public class SQLQueryTaxation {

    public static class MasterQuery {

        public static String SELECT_MASTER_LIST_ASSUJETTIS_BY_CRITERION = "SELECT a.CODE,a.NIF,a.NOM,"
                + " a.POSTNOM,a.PRENOMS,a.FORME_JURIDIQUE FROM T_PERSONNE a WITH (READPAST)"
                + " WHERE a.ETAT = 1 %s ";
        
        public static String SELECT_MASTER_LIST_ASSUJETTIS_BY_CRITERION_V2 = "SELECT a.CODE,a.NIF,a.NOM,"
                + " a.POSTNOM,a.PRENOMS,a.FORME_JURIDIQUE FROM T_PERSONNE a WITH (READPAST)"
                + " WHERE a.ETAT = 1 AND FORME_JURIDIQUE = '03' %s ";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL = "SELECT NC.* FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.ETAT = 2 AND NC.FK_ADRESSE_PERSONNE IN (SELECT DISTINCT AP.CODE FROM T_ADRESSE_PERSONNE AP"
                + " WHERE AP.PAR_DEFAUT = 1) %s %s %s AND NC.AGENT_CLOTURE IS NULL AND "
                + " NC.DATE_CLOTURE IS NULL AND NC.NUMERO IN (SELECT DISTINCT NOTE_CALCUL FROM T_DETAILS_NC WITH (READPAST)) "
                + " ORDER BY NC.NUMERO DESC";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL_CLOSED = "SELECT NC.* FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.ETAT = 1 AND NC.FK_ADRESSE_PERSONNE IN (SELECT DISTINCT AP.CODE FROM T_ADRESSE_PERSONNE AP"
                + " WHERE AP.PAR_DEFAUT = 1) %s %s %s AND NOT NC.AGENT_CLOTURE IS NULL AND "
                + " NOT NC.DATE_CLOTURE IS NULL AND NC.NUMERO IN (SELECT DISTINCT NOTE_CALCUL FROM T_DETAILS_NC WITH (READPAST)) "
                + " ORDER BY NC.NUMERO DESC";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL_TO_ORDONNANCE = "SELECT NC.* FROM T_NOTE_CALCUL NC WITH (READPAST) "
                + " WHERE NC.ETAT = 1 AND NC.FK_ADRESSE_PERSONNE IN (SELECT DISTINCT AP.CODE FROM T_ADRESSE_PERSONNE AP"
                + " WHERE AP.PAR_DEFAUT = 1) %s %s %s AND NOT NC.AGENT_CLOTURE IS NULL AND NC.AGENT_VALIDATION IS NULL AND NC.AVIS IS NULL AND "
                + " NOT NC.DATE_CLOTURE IS NULL AND NC.NUMERO IN (SELECT DISTINCT NOTE_CALCUL FROM T_DETAILS_NC WITH (READPAST)) "
                + " ORDER BY NC.NUMERO DESC";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL_REJECTED = "SELECT NC.* FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.ETAT = 0 AND NC.FK_ADRESSE_PERSONNE IN (SELECT DISTINCT AP.CODE FROM T_ADRESSE_PERSONNE AP"
                + " WHERE AP.PAR_DEFAUT = 1) %s %s %s AND NOT NC.AGENT_CLOTURE IS NULL AND "
                + " NOT NC.DATE_CLOTURE IS NULL AND NC.NUMERO IN (SELECT DISTINCT NOTE_CALCUL FROM T_DETAILS_NC WITH (READPAST)) "
                + " ORDER BY NC.NUMERO DESC";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL_REJECTED_ORDONNANCEMENT = "SELECT NC.* FROM T_NOTE_CALCUL NC WITH (READPAST)"
                + " WHERE NC.AVIS = 'AV0022015' AND NC.FK_ADRESSE_PERSONNE IN (SELECT DISTINCT AP.CODE FROM T_ADRESSE_PERSONNE AP"
                + " WHERE AP.PAR_DEFAUT = 1) %s %s %s AND NOT NC.AGENT_VALIDATION IS NULL AND "
                + " NOT NC.DATE_VALIDATION IS NULL AND NC.NUMERO IN (SELECT DISTINCT NOTE_CALCUL FROM T_DETAILS_NC WITH (READPAST)) "
                + " ORDER BY NC.NUMERO DESC";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL_ADVANCED_1 = "SELECT NC.* FROM T_NOTE_CALCUL NC "
                + " WITH (READPAST) WHERE NC.ETAT = 1 %s %s %s ORDER BY NC.NUMERO DESC";

        public static String SELECT_MASTER_REGISTER_NOTE_CALCUL_ADVANCED_2 = "SELECT NC.* FROM T_NOTE_CALCUL NC "
                + " WITH (READPAST) %s %s %s ORDER BY NC.NUMERO DESC";

        public static String SELECT_LIST_ARTICLE_BUDGETAIRE_CONDUCTEUR_MOTO = "SELECT AB.* FROM T_ARTICLE_BUDGETAIRE AB WITH (READPAST) WHERE AB.CODE IN (%s)";

        public static String SELECT_LIST_ARCHIVE_ACCUSER_BY_ID_DOCUMENT = "SELECT AC.* FROM T_ARCHIVE_ACCUSE_RECEPTION AC "
                + " WITH (READPAST) WHERE AC.DOCUMENT_REFERENCE = ?1";
    }

    public static class SecondaryQuery {

        public static String SQL_QUERY_SECONDARY_ONE_FOR_LIST_ASSUJETTI = " AND (a.CODE = ?1 OR a.NIF = ?1)";
        public static String SQL_QUERY_SECONDARY_TWO_FOR_LIST_ASSUJETTI = " AND (a.NOM LIKE ?1 OR a.POSTNOM LIKE ?1 OR a.PRENOMS LIKE ?1) ORDER BY a.NOM,a.POSTNOM,a.PRENOMS";
        public static String SQL_QUERY_SECONDARY_LIST_ASSUJETTI_WITH_LIKE = " AND (a.CODE = ?1 OR a.NIF = ?1 OR a.NOM LIKE ?1 OR a.POSTNOM LIKE ?1 OR a.PRENOMS LIKE ?1) ORDER BY a.NOM,a.POSTNOM,a.PRENOMS";
        public static String SQL_QUERY_SECONDARY_ONE_REGISTER_NOTE_CALCUL = " AND DBO.F_GET_PERSONNE_NAME(NC.PERSONNE) LIKE ?1";
        public static String SQL_QUERY_SECONDARY_TWO_REGISTER_NOTE_CALCUL = " AND NC.NUMERO = ?1";

        public static String SQL_QUERY_SECONDARY_THREE_REGISTER_NOTE_CALCUL = " AND NC.SITE = '%s' AND "
                + " NC.SITE IN (SELECT DISTINCT AST.CODESITE FROM T_AGENT_SITE AST WITH (READPAST) "
                + " WHERE AST.CODEAGENT = %s AND AST.ETAT = 1)";

        public static String SQL_QUERY_SECONDARY_THREE_REGISTER_NOTE_CALCUL_V2 = " AND NC.SITE = '%s'";

        public static String SQL_QUERY_SECONDARY_FOURT_REGISTER_NOTE_CALCUL = " AND NC.SERVICE = '%s'";

        public static String SQL_QUERY_SECONDARY_ONE_NOTE_CALCUL_ADVANCED = " AND DBO.FDATE(NC.DATE_CREAT) BETWEEN '%s' AND '%s'";

        public static String SQL_QUERY_SECONDARY_TWO_NOTE_CALCUL_ADVANCED = " AND NC.SERVICE = '%s'";

        public static String SQL_QUERY_SECONDARY_THREE_NOTE_CALCUL_ADVANCED = " AND NC.SITE = '%s' AND DBO.FDATE(NC.DATE_CREAT) "
                + " BETWEEN '%s' AND '%s'";
    }

    public static class SimpleQuery {

        public static String SELECT_ONE_LINE_DETAIL_NC_BY_NC = "SELECT TOP 1 * FROM T_DETAILS_NC WITH (READPAST)"
                + " WHERE NOTE_CALCUL = ?1 AND ETAT = 1";

        public static String SELECT_COMPLEMENT_PERSONNE_BY_PARAMS = "SELECT * FROM T_COMPLEMENT WHERE FK_COMPLEMENT_FORME IN (SELECT DISTINCT CODE "
                + " FROM T_COMPLEMENT_FORME WHERE FORME_JURIDIQUE = ?1 AND COMPLEMENT = ?2 AND ETAT = 1) "
                + " AND PERSONNE = ?3 AND ETAT = 1 ";

        public static String SELECT_AVIS_BY_ID = "SELECT * FROM T_AVIS WITH (READPAST) WHERE ID = ?1";

        public static String SELECT_LIST_TARIF_BY_ARTICLE_BUDGETAIRE = "SELECT * FROM T_TARIF WITH (READPAST) "
                + " WHERE CODE IN (SELECT DISTINCT TARIF FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE =?1)";

        public static String SELECT_LIST_ALL_DEVISES = "SELECT * FROM T_DEVISE WITH (READPAST) WHERE ETAT = 1";
        public static String SELECT_LIST_DETAIL_NOTE_CALCUL_BY_NC = "SELECT * FROM T_DETAILS_NC WITH (READPAST) "
                + " WHERE NOTE_CALCUL = ?1 AND ETAT = 1";

        public static String SELECT_LIST_ALL_AVIS = "SELECT * FROM T_AVIS WITH (READPAST) WHERE ETAT = 1";
        public static String SELECT_LIST_ALL_SITES = "SELECT * FROM T_SITE WITH (READPAST) WHERE ETAT = 1";

        public static String SELECT_LIST_ALL_SITES_PEAGE = "SELECT * FROM T_SITE WITH (READPAST) WHERE ETAT = 1 AND PEAGE = 1 AND NOT SIGLE IS NULL ORDER BY INTITULE";
        public static String SELECT_LIST_ALL_TARIF_PEAGE = "SELECT * FROM T_TARIF WITH (READPAST) WHERE ETAT = 1 AND EST_TARIF_PEAGE = 1 ORDER BY INTITULE";
        public static String SELECT_LIST_ALL_AXE_PEAGE = "SELECT * FROM T_AXE WITH (READPAST) WHERE ETAT = 1 ORDER BY INTITULE";

        public static String SELECT_LIST_ALL_SERVICES = "SELECT * FROM T_SERVICE WITH (READPAST) WHERE ETAT = 1";

        public static String SELECT_LIST_ALL_ARTICLE_BUDGETAIRE_WITH_LIKE = "SELECT a.* FROM T_ARTICLE_BUDGETAIRE a WITH (READPAST) "
                + " WHERE a.INTITULE LIKE ?1 AND a.ETAT = 1 ORDER BY a.INTITULE";

        public static String SELECT_LIST_ALL_IMPOT_WITH_LIKE = "SELECT a.* FROM T_ARTICLE_BUDGETAIRE a WITH (READPAST) "
                + " WHERE a.INTITULE LIKE ?1 AND a.ETAT = 1 AND a.ASSUJETISSABLE = 1 AND a.CODE IN(SELECT FK_AB FROM T_BANQUE_AB bab WITH (READPAST) WHERE bab.FK_COMPTE = '%s') ORDER BY a.INTITULE";

        public static String SELECT_LIST_ARTICLE_BUDGETAIRE_WITH_LIKE_BY_SERVICE = "SELECT a.* FROM T_ARTICLE_BUDGETAIRE a WITH (READPAST) WHERE a.INTITULE LIKE ?1 "
                + " AND a.ETAT = 1 AND a.ARTICLE_GENERIQUE IN (SELECT b.CODE FROM T_ARTICLE_GENERIQUE b "
                + " WITH (READPAST) WHERE b.SERVICE_ASSIETTE = %s AND b.ETAT = 1) ORDER BY a.INTITULE";

        public static String SELECT_LIST_SITE_AGENT_AFFETED = "SELECT S.* FROM T_SITE S WITH (READPAST) WHERE S.CODE IN "
                + " (SELECT DISTINCT CODESITE FROM T_AGENT_SITE WITH (READPAST) "
                + " WHERE CODEAGENT = ?1 AND ETAT = 1) AND S.ETAT = 1";

        public static String SELECT_TARIF_CODE = "SELECT * FROM T_TARIF WITH (READPAST) WHERE CODE = ?1 AND ETAT = 1";

        public static String SELECT_UNITE_CODE = "SELECT * FROM T_UNITE WITH (READPAST) WHERE CODE = ?1";

        public static String SELECT_PALIER_BY_TARIF_AND_FORME_JURIDIQUE = "SELECT * FROM T_PALIER WITH (READPAST)"
                + " WHERE ARTICLE_BUDGETAIRE = ?1 AND TARIF = ?2 AND (TYPE_PERSONNE = ?3 OR TYPE_PERSONNE = '*')"
                + " AND ETAT = 1";

        public static String SELECT_PALIER_BY_TARIF_AND_FORME_JURIDIQUE_AND_BASE = "SELECT * FROM T_PALIER WITH (READPAST)"
                + " WHERE ARTICLE_BUDGETAIRE = ?1 AND TARIF = ?2 AND (TYPE_PERSONNE = ?3 OR TYPE_PERSONNE = '*')"
                + " AND ETAT = 1 AND (TAUX >= BORNE_INFERIEUR AND TAUX <= BORNE_SUPERIEUR)";

        public static String SELECT_TAUX_BY_DEVISE = "SELECT TOP (1)* FROM T_TAUX WITH (READPAST)"
                + " WHERE DEVISE = ?1 AND DEVISE_DEST = ?2 ORDER BY ID DESC";

        public static String SELECT_BUDGET_ARTICLE_BY_CODE = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST)"
                + " WHERE CODE = ?1";

        public static String SELECT_EXERCICE_FISCAL = "SELECT MAX(CODE) FROM T_EXERCICE_FISCALE WITH (READPAST)";
        public static String SELECT_PALIER_BY_CODE = "SELECT * FROM T_PALIER WITH (READPAST) "
                + " WHERE ARTICLE_BUDGETAIRE = ?1 AND TYPE_PERSONNE = ?2 AND (?3 <= BORNE_INFERIEURE "
                + " AND ?3>= BORNE_SUPERIEURE) AND ETAT=1";

        public static String SELECT_ADRESSE_BY_PERSONNE = "SELECT * FROM T_ADRESSE WITH (READPAST) "
                + " WHERE ID IN (SELECT DISTINCT ADRESSE FROM T_ADRESSE_PERSONNE WITH (READPAST) "
                + " WHERE PERSONNE = ?1 AND PAR_DEFAUT = 1 AND ETAT = 1)";

        public static String SELECT_PALIER_BY_ARTICLE = "SELECT * FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE = ?1 AND ETAT = 1";

        public static String SELECT_PALIER_BY_ARTICLE_WITH_PALIER = "SELECT TOP 1 * FROM T_PALIER WITH (READPAST) "
                + " WHERE ARTICLE_BUDGETAIRE = ?1 AND ETAT = 1 AND %s >= BORNE_INFERIEURE AND %s <= BORNE_SUPERIEURE";

        public static String SELECT_NOTE_CALCUL_BY_NUMERO = "SELECT * FROM T_NOTE_CALCUL WITH (READPAST) WHERE NUMERO = ?1";

        public static String SELECT_UNITE_COMPLEMENT = "SELECT  DBO.F_GET_UNITE('%s')";

        public static String SELECT_UNITE_COMPLEMENT2 = "SELECT  DBO.F_GET_UNITE2('%s')";

        public static String SELECT_FICHE_PRISE_CHARGE = "SELECT * FROM T_FICHE_PRISE_CHARGE WITH (READPAST)"
                + " WHERE NUMERO_REFERENCE = ?1 ";

        public static String SELECT_LIST_ALL_UNITES = "SELECT * FROM T_UNITE WITH (READPAST) WHERE ETAT = 1 ORDER BY INTITULE";

        public static String SELECT_AB_AMENDE_BY_SERVICE_ASSIETTE = "SELECT AB.* FROM T_ARTICLE_BUDGETAIRE AB "
                + " WITH (READPAST) WHERE AB.NATURE = ?1 AND AB.ARTICLE_GENERIQUE IN (SELECT AG.CODE "
                + " FROM T_ARTICLE_GENERIQUE AG WITH (READPAST) WHERE AG.SERVICE_ASSIETTE = ?2)";
    }

    public static class GetQuery {

        public static String GET_TAUX_PALIER_BY_CODE = "SELECT DBO.GET_TAUX_PALIER %s";
        public static String GET_NUMBER_TARIF_BY_ARTICLE_BUDGETAIRE = "SELECT COUNT(*) nbre FROM T_TARIF WITH (READPAST)"
                + " WHERE CODE IN (SELECT DISTINCT TARIF FROM T_PALIER WITH (READPAST)WHERE ARTICLE_BUDGETAIRE = %s";

        public static String GET_MONTANT_TOTAL_DETAIL_NC = "SELECT dbo.F_GET_TOTAL_MONTANT_DU_DNC %s";
        public static String GET_TAUX_BY_DEVISE = "SELECT dbo.F_GET_TAUX_DEVISE %s";
    }

    public static class ExecuteQuery {

        public static String EXEC_STORED_PROCEDURE_F_GET_TAUX_NF_WEB = "EXEC F_GET_TAUX_NF_WEB ?1,?2,?3,?4,?5,?6";
        public static String EXEC_F_CLOTURE_NC = "EXEC F_CLOTURE_NC ?1,?2,?3,?4";
        //public static String EXEC_F_NEW_DNC = ":EXEC F_NEW_DNC ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11";
        public static String EXEC_F_NEW_DNC = ":EXEC F_NEW_DNC ?1,'%s',?2,?3,?4,?5,?6,?7,?8,?9,?10";
        public static String INSERT_BIEN_TATXATION = ":INSERT INTO T_BIEN_NOTE_CALCUL (FK_NC,FK_BIEN,ETAT,MESSAGE) VALUES ('%s',?1, 1,?2)";

        public static String EXEC_F_NEW_SUIVI_DECLARATION_NC_V2 = ":EXEC F_NEW_SUIVI_DECLARATION '%s','%s',?1,?2,?3,?4,?5";
        public static String EXEC_F_NEW_SUIVI_DECLARATION_NC_V3 = ":EXEC F_NEW_SUIVI_DECLARATION ?1,'%s',?2,?3,?4,?5,?6";

        public static String EXEC_F_GET_TAUX_NF = "EXEC F_GET_TAUX_NF ?1,?2,?3,?4,?5,?6";
        public static String EXEC_F_NEW_JDOSSIER = ":EXEC F_NEW_JDOSSIER ?1,?2,?3,?4,?5,?6,?7,?8";
        public static String EXEC_F_NEW_SUIVI_DECLARATION = ":EXEC F_NEW_SUIVI_DECLARATION ?1,?2,?3,?4,?5,?6,?7 ";
        public static String EXEC_F_NEW_CREDIT_IMPOT = ":EXEC F_NEW_CREDIT_IMPOT_WEB ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10 ";

        public static String EXEC_F_NEW_NOTE_PERCEPTION_PENALITE_V2 = ":EXEC F_NEW_NOTE_PERCEPTION_PENALITE ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16,?17";
        public static String F_UPDATE_QTE_UTILISEE_DISPATCH = ":UPDATE T_DISPATCH_SERIE SET QTE_UTILISEE = QTE_UTILISEE + %s WHERE ID = ?1";

    }

}
